# Interface RandomGenerator.StreamableGenerator

All Superinterfaces:
  `RandomGenerator`

All Known Subinterfaces:
  `RandomGenerator.ArbitrarilyJumpableGenerator, RandomGenerator.JumpableGenerator, RandomGenerator.LeapableGenerator, RandomGenerator.SplittableGenerator`

All Known Implementing Classes:
  `SplittableRandom`

Enclosing interface:
  `RandomGenerator`

public static interface RandomGenerator.StreamableGenerator extends RandomGenerator
The `RandomGenerator.StreamableGenerator` interface augments the `RandomGenerator` interface to provide methods that return streams of `RandomGenerator` objects. Ideally, such a stream of objects would have the property that the behavior of each object is statistically independent of all the others. In practice, one may have to settle for some approximation to this property.

A generator that implements interface `RandomGenerator.SplittableGenerator` may choose to use its `splits`() method to implement the `rngs`() method required by this interface.

A generator that implements interface `RandomGenerator.JumpableGenerator` may choose to use its `jumps`() method to implement the `rngs`() method required by this interface.

A generator that implements interface `RandomGenerator.LeapableGenerator` may choose to use its `leaps`() method to implement the `rngs`() method required by this interface.

Objects that implement `RandomGenerator.StreamableGenerator` are typically not cryptographically secure. Consider instead using `SecureRandom` to get a cryptographically secure pseudo-random number generator for use by security-sensitive applications.

Since:
  17

## Nested Class Summary

### Nested classes/interfaces declared in interface RandomGenerator

`RandomGenerator.ArbitrarilyJumpableGenerator, RandomGenerator.JumpableGenerator, RandomGenerator.LeapableGenerator, RandomGenerator.SplittableGenerator, RandomGenerator.StreamableGenerator`
Modifier and Type
Interface
Description
`static interface`
`RandomGenerator.ArbitrarilyJumpableGenerator`
This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can easily jump forward, by an arbitrary amount, to a distant point in the state cycle.
`static interface`
`RandomGenerator.JumpableGenerator`
This interface is designed to provide a common protocol for objects that generate pseudorandom values and can easily jump forward, by a moderate amount (ex. 264) to a distant point in the state cycle.
`static interface`
`RandomGenerator.LeapableGenerator`
This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can easily not only jump but also leap forward, by a large amount (ex. 2128), to a very distant point in the state cycle.
`static interface`
`RandomGenerator.SplittableGenerator`
This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can be split into two objects (the original one and a new one) each of which obey that same protocol (and therefore can be recursively split indefinitely).
`static interface`
`RandomGenerator.StreamableGenerator`
The `RandomGenerator.StreamableGenerator` interface augments the `RandomGenerator` interface to provide methods that return streams of `RandomGenerator` objects.

## Method Summary

Modifier and Type
Method
Description
`static RandomGenerator.StreamableGenerator`
`of(String name)`
Returns an instance of `RandomGenerator.StreamableGenerator` that utilizes the `name` algorithm.
`Stream<RandomGenerator>`
`rngs()`
Returns an effectively unlimited stream of objects, each of which implements the `RandomGenerator` interface.
`default Stream<RandomGenerator>`
`rngs(long streamSize)`
Returns an effectively unlimited stream of objects, each of which implements the `RandomGenerator` interface.

### Methods declared in interface RandomGenerator

`doubles, doubles, doubles, doubles, equiDoubles, ints, ints, ints, ints, isDeprecated, longs, longs, longs, longs, nextBoolean, nextBytes, nextDouble, nextDouble, nextDouble, nextExponential, nextFloat, nextFloat, nextFloat, nextGaussian, nextGaussian, nextInt, nextInt, nextInt, nextLong, nextLong, nextLong`
Modifier and Type
Method
Description
`default DoubleStream`
`doubles()`
Returns an effectively unlimited stream of pseudorandomly chosen `double` values.
`default DoubleStream`
`doubles(double randomNumberOrigin, double randomNumberBound)`
Returns an effectively unlimited stream of pseudorandomly chosen `double` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
`default DoubleStream`
`doubles(long streamSize)`
Returns a stream producing the given `streamSize` number of pseudorandomly chosen `double` values.
`default DoubleStream`
`doubles(long streamSize, double randomNumberOrigin, double randomNumberBound)`
Returns a stream producing the given `streamSize` number of pseudorandomly chosen `double` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
`default DoubleStream`
`equiDoubles(double left, double right, boolean isLeftIncluded, boolean isRightIncluded)`
Returns an effectively unlimited stream of pseudorandomly chosen `double` values, where each value is between the specified `left` boundary and the specified `right` boundary.
`default IntStream`
`ints()`
Returns an effectively unlimited stream of pseudorandomly chosen `int` values.
`default IntStream`
`ints(int randomNumberOrigin, int randomNumberBound)`
Returns an effectively unlimited stream of pseudorandomly chosen `int` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
`default IntStream`
`ints(long streamSize)`
Returns a stream producing the given `streamSize` number of pseudorandomly chosen `int` values.
`default IntStream`
`ints(long streamSize, int randomNumberOrigin, int randomNumberBound)`
Returns a stream producing the given `streamSize` number of pseudorandomly chosen `int` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
`default boolean`
`isDeprecated()`
Return true if the implementation of RandomGenerator (algorithm) has been marked for deprecation.
`default LongStream`
`longs()`
Returns an effectively unlimited stream of pseudorandomly chosen `long` values.
`default LongStream`
`longs(long streamSize)`
Returns a stream producing the given `streamSize` number of pseudorandomly chosen `long` values.
`default LongStream`
`longs(long randomNumberOrigin, long randomNumberBound)`
Returns an effectively unlimited stream of pseudorandomly chosen `long` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
`default LongStream`
`longs(long streamSize, long randomNumberOrigin, long randomNumberBound)`
Returns a stream producing the given `streamSize` number of pseudorandomly chosen `long` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
`default boolean`
`nextBoolean()`
Returns a pseudorandomly chosen `boolean` value.
`default void`
`nextBytes(byte[] bytes)`
Fills a user-supplied byte array with generated byte values pseudorandomly chosen uniformly from the range of values between -128 (inclusive) and 127 (inclusive).
`default double`
`nextDouble()`
Returns a pseudorandom `double` value between zero (inclusive) and one (exclusive).
`default double`
`nextDouble(double bound)`
Returns a pseudorandomly chosen `double` value between zero (inclusive) and the specified bound (exclusive).
`default double`
`nextDouble(double origin, double bound)`
Returns a pseudorandomly chosen `double` value between the specified origin (inclusive) and the specified bound (exclusive).
`default double`
`nextExponential()`
Returns a nonnegative `double` value pseudorandomly chosen from an exponential distribution whose mean is 1.
`default float`
`nextFloat()`
Returns a pseudorandom `float` value between zero (inclusive) and one (exclusive).
`default float`
`nextFloat(float bound)`
Returns a pseudorandomly chosen `float` value between zero (inclusive) and the specified bound (exclusive).
`default float`
`nextFloat(float origin, float bound)`
Returns a pseudorandomly chosen `float` value between the specified origin (inclusive) and the specified bound (exclusive).
`default double`
`nextGaussian()`
Returns a `double` value pseudorandomly chosen from a Gaussian (normal) distribution whose mean is 0 and whose standard deviation is 1.
`default double`
`nextGaussian(double mean, double stddev)`
Returns a `double` value pseudorandomly chosen from a Gaussian (normal) distribution with a mean and standard deviation specified by the arguments.
`default int`
`nextInt()`
Returns a pseudorandomly chosen `int` value.
`default int`
`nextInt(int bound)`
Returns a pseudorandomly chosen `int` value between zero (inclusive) and the specified bound (exclusive).
`default int`
`nextInt(int origin, int bound)`
Returns a pseudorandomly chosen `int` value between the specified origin (inclusive) and the specified bound (exclusive).
`long`
`nextLong()`
Returns a pseudorandomly chosen `long` value.
`default long`
`nextLong(long bound)`
Returns a pseudorandomly chosen `long` value between zero (inclusive) and the specified bound (exclusive).
`default long`
`nextLong(long origin, long bound)`
Returns a pseudorandomly chosen `long` value between the specified origin (inclusive) and the specified bound (exclusive).

## Method Details

### of

static RandomGenerator.StreamableGenerator of(String name)
Returns an instance of `RandomGenerator.StreamableGenerator` that utilizes the `name` algorithm.

Parameters:
  `name` - Name of random number generator algorithm
Returns:
  An instance of `RandomGenerator.StreamableGenerator`
Throws:
  `NullPointerException` - if name is null
  `IllegalArgumentException` - if the named algorithm is not found

### rngs

Stream<RandomGenerator> rngs()
Returns an effectively unlimited stream of objects, each of which implements the `RandomGenerator` interface. Ideally the generators in the stream will appear to be statistically independent. The new generators are of the same algorithm as this generator.

Implementation Note:
  It is permitted to implement this method in a manner equivalent to `rngs` (`Long.MAX_VALUE`).
Returns:
  a stream of objects that implement the `RandomGenerator` interface

### rngs

default Stream<RandomGenerator> rngs(long streamSize)
Returns an effectively unlimited stream of objects, each of which implements the `RandomGenerator` interface. Ideally the generators in the stream will appear to be statistically independent. The new generators are of the same algorithm as this generator.

Implementation Requirements:
  The default implementation calls `rngs`() and then limits its length to `streamSize`.
Parameters:
  `streamSize` - the number of generators to generate
Returns:
  a stream of objects that implement the `RandomGenerator` interface
Throws:
  `IllegalArgumentException` - if `streamSize` is less than zero